Codeforces Round #242 (Div. 2) B. Megacity

The administration of the Tomsk Region firmly believes that it‘s time to become a megacity (that is, get population of one million). Instead of improving the demographic situation, they decided to achieve its goal by expanding the boundaries of the city.

The city of Tomsk can be represented as point on the plane with coordinates (0;
0). The city is surrounded with
n other locations, the i-th one has coordinates (xi,
yi) with the population of
ki people. You can widen the city boundaries to a circle of radius
r. In such case all locations inside the circle and on its border are included into the city.

Your goal is to write a program that will determine the minimum radius
r, to which is necessary to expand the boundaries of Tomsk, so that it becomes a megacity.

Input

The first line of the input contains two integers n and
s (1?≤?n?≤?103;
1?≤?s?<?106) — the number of locatons around Tomsk city and the population of the city. Then
n lines follow. The
i-th line contains three integers — the xi and
yi coordinate values of the
i-th location and the number
ki of people in it (1?≤?ki?<?106). Each coordinate is an integer and doesn‘t exceed
104 in its absolute value.

It is guaranteed that no two locations are at the same point and no location is at point (0; 0).

Output

In the output, print "-1" (without the quotes), if Tomsk won‘t be able to become a megacity. Otherwise, in the first line print a single real number — the minimum radius of the circle that the city needs to expand to
in order to become a megacity.

The answer is considered correct if the absolute or relative error don‘t exceed
10?-?6.

Sample test(s)

Input

4 999998
1 1 1
2 2 1
3 3 1
2 -2 1

Output

2.8284271

Input

4 999998
1 1 2
2 2 1
3 3 1
2 -2 1

Output

1.4142136

Input

2 1
1 1 999997
2 2 1

Output

-1

题意:n个城市,每个城市有坐标和人口,求以远点为圆心的最小的圆使得人口总数达到上限

思路:贪心

#include <iostream>
#include <cstdio>
#include <cstring>
#include <map>
#include <algorithm>
#include <cmath>
using namespace std;
const int maxn = 1010;
const int inf = 1e6;

map<double, int> mp;

double dis(int x, int y) {
	return sqrt(x*x+y*y);
}

int main() {
	int n, s, x, y, k;
	scanf("%d%d", &n, &s);
	for (int i = 0; i < n; i++) {
		scanf("%d%d%d", &x, &y, &k);
		mp[dis(x, y)] += k;
	}	

	map<double, int>::iterator it;
	double ans = -1;
	for (it = mp.begin(); it != mp.end(); it++) {
		if (s >= inf)
			break;
		s += it->second;
		ans = it->first;
	}

	if (s < inf)
		printf("-1\n");
	else printf("%.7lf\n", ans);
}
时间: 2024-08-26 20:35:26

Codeforces Round #242 (Div. 2) B. Megacity的相关文章

Codeforces Round #242 (Div. 2)C(找规律,异或运算)

一看就是找规律的题.只要熟悉异或的性质,可以秒杀. 为了防止忘记异或的规则,可以把异或理解为半加运算:其运算法则相当于不带进位的二进制加法. 一些性质如下: 交换律: 结合律: 恒等律: 归零律: 典型应用:交换a和b的值:a=a^b^(b=a); #include<iostream> #include<cstdio> #include<cstdlib> #include<cstring> #include<cmath> #include<

Codeforces Round #242 (Div. 2) A. Squats

Pasha has many hamsters and he makes them work out. Today, n hamsters (n is even) came to work out. The hamsters lined up and each hamster either sat down or stood up. For another exercise, Pasha needs exactly hamsters to stand up and the other hamst

Codeforces Round #279 (Div. 2) ABCD

Codeforces Round #279 (Div. 2) 做得我都变绿了! Problems # Name     A Team Olympiad standard input/output 1 s, 256 MB  x2377 B Queue standard input/output 2 s, 256 MB  x1250 C Hacking Cypher standard input/output 1 s, 256 MB  x740 D Chocolate standard input/

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿

Codeforces Round #424 (Div. 2) C. Jury Marks(乱搞)

题目链接:Codeforces Round #424 (Div. 2) C. Jury Marks 题意: 给你一个有n个数序列,现在让你确定一个x,使得x通过挨着加这个序列的每一个数能出现所有给出的k个数. 问合法的x有多少个.题目保证这k个数完全不同. 题解: 显然,要将这n个数求一下前缀和,并且排一下序,这样,能出现的数就可以表示为x+a,x+b,x+c了. 这里 x+a,x+b,x+c是递增的.这里我把这个序列叫做A序列 然后对于给出的k个数,我们也排一下序,这里我把它叫做B序列,如果我

[Codeforces] Round #352 (Div. 2)

人生不止眼前的狗血,还有远方的狗带 A题B题一如既往的丝帛题 A题题意:询问按照12345678910111213...的顺序排列下去第n(n<=10^3)个数是多少 题解:打表,输出 1 #include<bits/stdc++.h> 2 using namespace std; 3 int dig[10],A[1005]; 4 int main(){ 5 int aa=0; 6 for(int i=1;;i++){ 7 int x=i,dd=0; 8 while(x)dig[++dd

Codeforces Round #273 (Div. 2)

Codeforces Round #273 (Div. 2) 题目链接 A:签到,仅仅要推断总和是不是5的倍数就可以,注意推断0的情况 B:最大值的情况是每一个集合先放1个,剩下都丢到一个集合去,最小值是尽量平均去分 C:假如3种球从小到大是a, b, c,那么假设(a + b) 2 <= c这个比較明显答案就是a + b了.由于c肯定要剩余了,假设(a + b)2 > c的话,就肯定能构造出最优的(a + b + c) / 3,由于肯定能够先拿a和b去消除c,而且控制a和b成2倍关系或者消除

Codeforces Round #339 (Div. 2) B. Gena&#39;s Code

B. Gena's Code It's the year 4527 and the tanks game that we all know and love still exists. There also exists Great Gena's code, written in 2016. The problem this code solves is: given the number of tanks that go into the battle from each country, f